/* eslint no-param-reassign: 0, no-shadow: 0 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getFieldsFromContext = getFieldsFromContext;
exports.getRelationsFromFields = getRelationsFromFields;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function getFieldsFromContext(info, fieldNodes) {
  if (!info) {
    return {};
  }

  fieldNodes = fieldNodes || info.fieldNodes;

  // for recursion
  // Fragments doesn't have many sets
  var asts = fieldNodes;
  if (!Array.isArray(asts)) {
    asts = [asts];
  }

  // get all selectionSets
  var selections = asts.reduce(function (selections, source) {
    if (source.selectionSet) {
      selections.push.apply(selections, _toConsumableArray(source.selectionSet.selections));
    }

    return selections;
  }, []);

  // return fields
  return selections.reduce(function (list, ast) {
    var name = ast.name;
    var kind = ast.kind;

    switch (kind) {
      case 'Field':
        var fields = getFieldsFromContext(info, ast);
        return _extends({}, list, _defineProperty({}, name.value, !_lodash2['default'].isEmpty(fields) ? fields : true));
      case 'InlineFragment':
        return _extends({}, list, getFieldsFromContext(info, ast));
      case 'FragmentSpread':
        return _extends({}, list, getFieldsFromContext(info, info.fragments[name.value]));
      default:
        throw new Error('Unsuported query selection');
    }
  }, {});
}

function getRelationsFromFields(fields) {
  var relationFields = _lodash2['default'].omitBy(fields, function (field) {
    return !_lodash2['default'].isObject(field);
  });

  if (_lodash2['default'].isEmpty(relationFields)) {
    return true;
  }

  return _lodash2['default'].mapValues(relationFields, function (relationFields) {
    return getRelationsFromFields(relationFields);
  });
}