'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.nodeDefinitions = nodeDefinitions;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _graphqlRelay = require('graphql-relay');

function nodeDefinitions(_ref) {
  var _this = this;

  var connect = _ref.connect;
  var _ref$runQuery = _ref.runQuery;
  var runQuery = _ref$runQuery === undefined ? function callee$1$0(query) {
    var connection, result;
    return regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          (0, _assert2['default'])(_lodash2['default'].isFunction(connect), 'connect should be function');
          context$2$0.next = 3;
          return regeneratorRuntime.awrap(connect());

        case 3:
          connection = context$2$0.sent;
          context$2$0.next = 6;
          return regeneratorRuntime.awrap(query.run(connection));

        case 6:
          result = context$2$0.sent;

          connection.close();
          return context$2$0.abrupt('return', result);

        case 9:
        case 'end':
          return context$2$0.stop();
      }
    }, null, _this);
  } : _ref$runQuery;
  return (function () {
    var resolvers = {};

    function hasType(type) {
      return _lodash2['default'].has(resolvers, type);
    }

    function registerType(_ref2) {
      var _this2 = this;

      var type = _ref2.type;
      var table = _ref2.table;
      var _ref2$assert = _ref2.assert;
      var assertHook = _ref2$assert === undefined ? function callee$3$0() {
        return regeneratorRuntime.async(function callee$3$0$(context$4$0) {
          while (1) switch (context$4$0.prev = context$4$0.next) {
            case 0:
            case 'end':
              return context$4$0.stop();
          }
        }, null, _this2);
      } : _ref2$assert;
      var _ref2$resolve = _ref2.resolve;
      var resolveHook = _ref2$resolve === undefined ? function callee$3$0(obj) {
        return regeneratorRuntime.async(function callee$3$0$(context$4$0) {
          while (1) switch (context$4$0.prev = context$4$0.next) {
            case 0:
              return context$4$0.abrupt('return', /* context, info */obj);

            case 1:
            case 'end':
              return context$4$0.stop();
          }
        }, null, _this2);
      } : _ref2$resolve;
      var _ref2$afterQuery = _ref2.afterQuery;
      var afterQuery = _ref2$afterQuery === undefined ? function callee$3$0(query) {
        return regeneratorRuntime.async(function callee$3$0$(context$4$0) {
          while (1) switch (context$4$0.prev = context$4$0.next) {
            case 0:
              return context$4$0.abrupt('return', query);

            case 1:
            case 'end':
              return context$4$0.stop();
          }
        }, null, _this2);
      } : _ref2$afterQuery;

      if (hasType(type.name)) return;
      resolvers[type.name] = { type: type, table: table, assertHook: assertHook, resolveHook: resolveHook, afterQuery: afterQuery };
    }

    function resolveObj(globalId, context, info) {
      var _fromGlobalId, type, id, _resolvers$type, table, assertHook, resolveHook, afterQuery, query, obj;

      return regeneratorRuntime.async(function resolveObj$(context$3$0) {
        while (1) switch (context$3$0.prev = context$3$0.next) {
          case 0:
            _fromGlobalId = (0, _graphqlRelay.fromGlobalId)(globalId);
            type = _fromGlobalId.type;
            id = _fromGlobalId.id;

            if (hasType(type)) {
              context$3$0.next = 5;
              break;
            }

            return context$3$0.abrupt('return', null);

          case 5:
            _resolvers$type = resolvers[type];
            table = _resolvers$type.table;
            assertHook = _resolvers$type.assertHook;
            resolveHook = _resolvers$type.resolveHook;
            afterQuery = _resolvers$type.afterQuery;
            context$3$0.next = 12;
            return regeneratorRuntime.awrap(assertHook(id, context, info));

          case 12:
            query = table.get(id);
            context$3$0.next = 15;
            return regeneratorRuntime.awrap(afterQuery(query, context, info));

          case 15:
            query = context$3$0.sent;
            context$3$0.next = 18;
            return regeneratorRuntime.awrap(runQuery(query));

          case 18:
            obj = context$3$0.sent;
            context$3$0.next = 21;
            return regeneratorRuntime.awrap(resolveHook(obj, context, info));

          case 21:
            obj = context$3$0.sent;

            if (!_lodash2['default'].isNull(obj)) {
              context$3$0.next = 24;
              break;
            }

            return context$3$0.abrupt('return', null);

          case 24:
            obj._dataType = type;
            return context$3$0.abrupt('return', obj);

          case 26:
          case 'end':
            return context$3$0.stop();
        }
      }, null, this);
    }

    function resolveType(obj) {
      if (_lodash2['default'].isNull(obj)) return null;
      var type = resolvers[obj._dataType].type;

      return type;
    }

    var _relayNodeDefinitions = (0, _graphqlRelay.nodeDefinitions)(resolveObj, resolveType);

    var nodeInterface = _relayNodeDefinitions.nodeInterface;
    var nodeField = _relayNodeDefinitions.nodeField;

    return {
      registerType: registerType,
      nodeInterface: nodeInterface,
      nodeField: nodeField
    };
  })();
}

/* id, context, info */